% $Header: slide.pro,v 0.0 88/06/22 05:22:44 on Rel $
% General macros

/Latin1vec [
% - Begin local extensions (CSC) -
	8#200	/ellipsis
	8#201	/bullet
	8#202	/trademark
	8#203	/dagger
	8#204	/daggerdbl
	8#205	/emdash
	8#206	/endash
% - Begin public Adobe extensions -
	8#220	/dotlessi
	8#221	/grave
	8#222	/acute
	8#223	/circumflex
	8#224	/tilde
	8#225	/macron		% also \257
	8#226	/breve
	8#227	/dotaccent
	8#230	/dieresis
%	8#231	/.notdef
	8#232	/ring
	8#233	/cedilla
%	8#234	/.notdef
	8#235	/hungarumlaut
	8#236	/ogonek
	8#237	/caron
% - End of extensions - Begin 8859-1 -
	8#240	/nobreakspace
	8#241	/exclamdown
	8#242	/cent
	8#243	/sterling
	8#244	/currency
	8#245	/yen
	8#246	/brokenbar
	8#247	/section
	8#250	/dieresis
	8#251	/copyright
	8#252	/ordfeminine
	8#253	/guillemotleft
	8#254	/logicalnot
	8#255	/hyphen
	8#256	/registered
	8#257	/macron
	8#260	/degree
	8#261	/plusminus
	8#262	/twosuperior
	8#263	/threesuperior
	8#264	/acute
	8#265	/mu
	8#266	/paragraph
	8#267	/periodcentered
	8#270	/cedilla
	8#271	/onesuperior
	8#272	/ordmasculine
	8#273	/guillemotright
	8#274	/onequarter
	8#275	/onehalf
	8#276	/threequarters
	8#277	/questiondown
	8#300	/Agrave
	8#301	/Aacute
	8#302	/Acircumflex
	8#303	/Atilde
	8#304	/Adieresis
	8#305	/Aring
	8#306	/AE
	8#307	/Ccedilla
	8#310	/Egrave
	8#311	/Eacute
	8#312	/Ecircumflex
	8#313	/Edieresis
	8#314	/Igrave
	8#315	/Iacute
	8#316	/Icircumflex
	8#317	/Idieresis
	8#320	/Eth
	8#321	/Ntilde
	8#322	/Ograve
	8#323	/Oacute
	8#324	/Ocircumflex
	8#325	/Otilde
	8#326	/Odieresis
	8#327	/multiply
	8#330	/Oslash
	8#331	/Ugrave
	8#332	/Uacute
	8#333	/Ucircumflex
	8#334	/Udieresis
	8#335	/Yacute
	8#336	/Thorn
	8#337	/germandbls
	8#340	/agrave
	8#341	/aacute
	8#342	/acircumflex
	8#343	/atilde
	8#344	/adieresis
	8#345	/aring
	8#346	/ae
	8#347	/ccedilla
	8#350	/egrave
	8#351	/eacute
	8#352	/ecircumflex
	8#353	/edieresis
	8#354	/igrave
	8#355	/iacute
	8#356	/icircumflex
	8#357	/idieresis
	8#360	/eth
	8#361	/ntilde
	8#362	/ograve
	8#363	/oacute
	8#364	/ocircumflex
	8#365	/otilde
	8#366	/odieresis
	8#367	/divide
	8#370	/oslash
	8#371	/ugrave
	8#372	/uacute
	8#373	/ucircumflex
	8#374	/udieresis
	8#375	/yacute
	8#376	/thorn
	8#377	/ydieresis
] def

/ReEncodeDict 6 dict def
/ReEncodeFont
  { ReEncodeDict begin
    /newcodesandnames exch def
    /newfontname exch def
    /basefontname exch def
    /basefontdict basefontname findfont def
    /newfont basefontdict maxlength dict def
    basefontdict
    {  exch dup /FID ne
       { dup /Encoding eq
         { exch dup length array copy
           newfont 3 1 roll put }
         { exch newfont 3 1 roll put }
         ifelse
       }
       { pop pop }
       ifelse
    } forall
    newfont /FontName newfontname put
    newcodesandnames aload pop
    newcodesandnames length 2 idiv
    { newfont /Encoding get 3 1 roll put }
    repeat
    newfontname newfont definefont	% Leave the new font on the stack.
    end
} def

/curx { currentpoint pop } bind def
/cury { currentpoint exch pop } bind def
/min { 2 copy gt { exch } if pop } bind def
/max { 2 copy lt { exch } if pop } bind def

/vecop {
% [ v1x v1y ] [ v2x v2y ] { op } vecop [ v1x v2x { op } v1y v2y { op } ]
	3 1 roll aload pop
	3 2 roll aload pop
	3 2 roll
	5 -1 roll dup 6 1 roll exec
	exch 4 2 roll exch exec
	exch
	[ 3 1 roll ]
} bind def
 
% Automatic stretching
/pagedim { % - pagedim [ llx lly ] [ urx ury ]
	initclip clippath pathbbox
	[ 3 1 roll ]
	3 1 roll
	[ 3 1 roll ]
} bind def

/ndim { % - ndim [ nx ny ]
	[ I setfont (n) stringwidth pop dy ]
} bind def

/stretch { % w h stretch -
	dup
	% How much can we magnify?
	pagedim { sub } vecop margin { sub } vecop	% page space
	exch { div } vecop
	aload pop min exch
	% How much can we magnify on rotated page?
	[ pagedim { sub } vecop margin { sub } vecop aload pop exch ]
	exch { div } vecop
	aload pop min exch

	gsave
	2 copy
	gt {	% landscape
		pagedim exch pop
		margin [ 2 2 ] { div } vecop { add } vecop
		aload pop translate
		90 rotate
		pop dup scale
	} {	% portrait
		[ pagedim 0 get exch 1 get ]
		margin [ 2 -2 ] { div } vecop { add } vecop
		aload pop translate
		dup scale pop
	} ifelse
	/txfrm matrix currentmatrix def
	grestore
} bind def

% pps instructions
/fname {	% string fname -
	/filename exch def
	/pageno 0 def
	1 f
} bind def

/fdate { /date exch def } bind def
/funct { pop } bind def

/t {	% ntabs t -
	{ 
		curx 1 add
		tabwidth div ceiling
		tabwidth mul
		cury moveto
	} repeat
} bind def

/n {	% nlines n -
	{ 0 cury dy sub moveto } repeat
} bind def

/f {	% npages f -
	{
		totalpage 0 gt {
			showpage
		} if
		/totalpage totalpage 1 add def
		/pageno pageno 1 add def
	} repeat

	txfrm setmatrix
	0 0 moveto
	1 n
} bind def
	
/s {	% string font s -
	setfont
	show
} bind def

/ppsinit { % width ht ppsinit -
	fonts {	% FontName Font
		exch dup 3 1 roll	% DstName SrcName DstName
		Latin1vec ReEncodeFont	% 1st & 2nd one used here.
%
%	If you like the font dimensions to be streched or squeezed
%	try the following. But please - make sure you know what you
%	are doing and even then - be extremely carefull.
%
%		exch dup 3 1 roll findfont /FontBBox get aload pop
%		/UY exch def	/UX exch def
%		/LY exch def	/LX exch def
%		/DY UY LY sub def
%		/DX UX LX sub def
%		/SlantFactor <angle-in-degrees>
%			dup sin exch cos div	% = <angle> tan
%			DY mul
%		def
%		[DX 0 SlantFactor DY 0 0] makefont
%
		dy ppoints scalefont def  % The 3rd goes here.
	} forall
	[ 3 1 roll ] ndim { mul } vecop stretch
	/tabwidth ndim 0 get tabstop mul def
	/totalpage 0 def
} bind def

/ppsdone {	% - ppsdone -
	1 f
} bind def

% Fonts -- should better be fixed pitch.
/fonts 4 dict def
fonts begin
	/C /NewCenturySchlbk-Roman def	% Comments
	/K /Courier-Bold def		% Keywords
	/S /Courier-Oblique def		% Strings
	/I /Courier def			% The rest
end

% Page parameters
/margin [ 60 60 ] def		% x, y margin in points
/ppoints 10 def			% pointsize -- do not change!
/dy ppoints def			% line spacing, >= ppoints
/tabstop 8 def			% ens per tabstop
%%EndProlog
